typedef	struct {
	char		opt;
	char		pfg;
	char		*str;
} option;

	char	*optarg = "";
	int	optind = 1;

static	char	*optcmp(char *str, char *ptn)
{
    while ( *ptn != '\0' ) {
	if ( *str != *ptn )
	    return NULL;
	str++;
	ptn++;
    }
    return str;
}
int	getopt_long(int ac, char *av[], option *tab)
{
    int     n;
    char    *p;
    static char *optstr = NULL;

    for ( ; ; ) {
	if ( optstr != NULL && *optstr != '\0' ) {
	    for ( n = 0 ; tab[n].str != NULL ; n++ ) {
		if ( tab[n].opt == *optstr ) {
		    optstr++;
		    if ( tab[n].pfg != 0 ) {
			if ( *optstr != '\0' )
			    optarg = optstr;
			else if ( optind < ac )
			    optarg = av[optind++];
			else if ( tab[n].pfg != 2 ) {
			    fprintf(stderr,
				"%s: option `-%c' requires an argument\n",
				av[0], tab[n].opt);
			    optstr = NULL;
		    	    return '\0';
			} else
			    optarg = NULL;
			optstr = NULL;
		    }
		    return tab[n].opt;
		}
	    }

	    fprintf(stderr, "%s: unrecognized option `-%c'\n", av[0], *optstr);
	    return *(optstr++);
	}

	if ( optind >= ac || *av[optind] != '-' )
	    return EOF;

	optstr = av[optind++] + 1;

	if ( *optstr == '-' ) {		/* -- */
	    optstr++;
	    for ( n = 0 ; tab[n].str != NULL ; n++ ) {
		if ( (p = optcmp(optstr, tab[n].str)) != NULL ) {
		    if ( tab[n].pfg != 0 ) {
		        optstr = p;
			if ( *optstr == '=' )
			    optstr++;

			if ( *optstr != '\0' )
			    optarg = optstr;
			else if ( optind < ac )
			    optarg = av[optind++];
			else if ( tab[n].pfg != 2 ) {
			    fprintf(stderr,
				"%s: option `--%s' requires an argument\n",
				av[0], tab[n].str);
			    optstr = NULL;
		    	    return '\0';
			} else
			    optarg = NULL;

		    } else if ( *p != '\0' )
			continue;

		    optstr = NULL;
		    return tab[n].opt;
		}
	    }

	    fprintf(stderr, "%s: unrecognized option `--%s'\n", av[0], optstr);
	    optstr = NULL;
	    return '\0';
	}
    }
}
